<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>AsyncNHttpServiceHandler xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../apidocs/org/apache/http/nio/protocol/AsyncNHttpServiceHandler.html">View Javadoc</a></div><pre>

<a class="jxr_linenumber" name="1" href="#1">1</a>   <em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="2" href="#2">2</a>   <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="3" href="#3">3</a>   <em class="jxr_comment"> * Licensed to the Apache Software Foundation (ASF) under one</em>
<a class="jxr_linenumber" name="4" href="#4">4</a>   <em class="jxr_comment"> * or more contributor license agreements.  See the NOTICE file</em>
<a class="jxr_linenumber" name="5" href="#5">5</a>   <em class="jxr_comment"> * distributed with this work for additional information</em>
<a class="jxr_linenumber" name="6" href="#6">6</a>   <em class="jxr_comment"> * regarding copyright ownership.  The ASF licenses this file</em>
<a class="jxr_linenumber" name="7" href="#7">7</a>   <em class="jxr_comment"> * to you under the Apache License, Version 2.0 (the</em>
<a class="jxr_linenumber" name="8" href="#8">8</a>   <em class="jxr_comment"> * "License"); you may not use this file except in compliance</em>
<a class="jxr_linenumber" name="9" href="#9">9</a>   <em class="jxr_comment"> * with the License.  You may obtain a copy of the License at</em>
<a class="jxr_linenumber" name="10" href="#10">10</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="11" href="#11">11</a>  <em class="jxr_comment"> *   <a href="http://www.apache.org/licenses/LICENSE-2.0" target="alexandria_uri">http://www.apache.org/licenses/LICENSE-2.0</a></em>
<a class="jxr_linenumber" name="12" href="#12">12</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="13" href="#13">13</a>  <em class="jxr_comment"> * Unless required by applicable law or agreed to in writing,</em>
<a class="jxr_linenumber" name="14" href="#14">14</a>  <em class="jxr_comment"> * software distributed under the License is distributed on an</em>
<a class="jxr_linenumber" name="15" href="#15">15</a>  <em class="jxr_comment"> * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY</em>
<a class="jxr_linenumber" name="16" href="#16">16</a>  <em class="jxr_comment"> * KIND, either express or implied.  See the License for the</em>
<a class="jxr_linenumber" name="17" href="#17">17</a>  <em class="jxr_comment"> * specific language governing permissions and limitations</em>
<a class="jxr_linenumber" name="18" href="#18">18</a>  <em class="jxr_comment"> * under the License.</em>
<a class="jxr_linenumber" name="19" href="#19">19</a>  <em class="jxr_comment"> * ====================================================================</em>
<a class="jxr_linenumber" name="20" href="#20">20</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="21" href="#21">21</a>  <em class="jxr_comment"> * This software consists of voluntary contributions made by many</em>
<a class="jxr_linenumber" name="22" href="#22">22</a>  <em class="jxr_comment"> * individuals on behalf of the Apache Software Foundation.  For more</em>
<a class="jxr_linenumber" name="23" href="#23">23</a>  <em class="jxr_comment"> * information on the Apache Software Foundation, please see</em>
<a class="jxr_linenumber" name="24" href="#24">24</a>  <em class="jxr_comment"> * &lt;<a href="http://www.apache.org/&gt;." target="alexandria_uri">http://www.apache.org/&gt;.</a></em>
<a class="jxr_linenumber" name="25" href="#25">25</a>  <em class="jxr_comment"> *</em>
<a class="jxr_linenumber" name="26" href="#26">26</a>  <em class="jxr_comment"> */</em>
<a class="jxr_linenumber" name="27" href="#27">27</a>  
<a class="jxr_linenumber" name="28" href="#28">28</a>  <strong class="jxr_keyword">package</strong> org.apache.http.nio.protocol;
<a class="jxr_linenumber" name="29" href="#29">29</a>  
<a class="jxr_linenumber" name="30" href="#30">30</a>  <strong class="jxr_keyword">import</strong> java.io.IOException;
<a class="jxr_linenumber" name="31" href="#31">31</a>  
<a class="jxr_linenumber" name="32" href="#32">32</a>  <strong class="jxr_keyword">import</strong> org.apache.http.ConnectionReuseStrategy;
<a class="jxr_linenumber" name="33" href="#33">33</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntity;
<a class="jxr_linenumber" name="34" href="#34">34</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpEntityEnclosingRequest;
<a class="jxr_linenumber" name="35" href="#35">35</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpException;
<a class="jxr_linenumber" name="36" href="#36">36</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpRequest;
<a class="jxr_linenumber" name="37" href="#37">37</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponse;
<a class="jxr_linenumber" name="38" href="#38">38</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpResponseFactory;
<a class="jxr_linenumber" name="39" href="#39">39</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpStatus;
<a class="jxr_linenumber" name="40" href="#40">40</a>  <strong class="jxr_keyword">import</strong> org.apache.http.HttpVersion;
<a class="jxr_linenumber" name="41" href="#41">41</a>  <strong class="jxr_keyword">import</strong> org.apache.http.MethodNotSupportedException;
<a class="jxr_linenumber" name="42" href="#42">42</a>  <strong class="jxr_keyword">import</strong> org.apache.http.ProtocolException;
<a class="jxr_linenumber" name="43" href="#43">43</a>  <strong class="jxr_keyword">import</strong> org.apache.http.ProtocolVersion;
<a class="jxr_linenumber" name="44" href="#44">44</a>  <strong class="jxr_keyword">import</strong> org.apache.http.UnsupportedHttpVersionException;
<a class="jxr_linenumber" name="45" href="#45">45</a>  <strong class="jxr_keyword">import</strong> org.apache.http.annotation.Immutable;
<a class="jxr_linenumber" name="46" href="#46">46</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.ContentDecoder;
<a class="jxr_linenumber" name="47" href="#47">47</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.ContentEncoder;
<a class="jxr_linenumber" name="48" href="#48">48</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.IOControl;
<a class="jxr_linenumber" name="49" href="#49">49</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.NHttpServerConnection;
<a class="jxr_linenumber" name="50" href="#50">50</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.NHttpServiceHandler;
<a class="jxr_linenumber" name="51" href="#51">51</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.entity.ConsumingNHttpEntity;
<a class="jxr_linenumber" name="52" href="#52">52</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.entity.NByteArrayEntity;
<a class="jxr_linenumber" name="53" href="#53">53</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.entity.NHttpEntityWrapper;
<a class="jxr_linenumber" name="54" href="#54">54</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.entity.ProducingNHttpEntity;
<a class="jxr_linenumber" name="55" href="#55">55</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.util.ByteBufferAllocator;
<a class="jxr_linenumber" name="56" href="#56">56</a>  <strong class="jxr_keyword">import</strong> org.apache.http.nio.util.HeapByteBufferAllocator;
<a class="jxr_linenumber" name="57" href="#57">57</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.DefaultedHttpParams;
<a class="jxr_linenumber" name="58" href="#58">58</a>  <strong class="jxr_keyword">import</strong> org.apache.http.params.HttpParams;
<a class="jxr_linenumber" name="59" href="#59">59</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.ExecutionContext;
<a class="jxr_linenumber" name="60" href="#60">60</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HttpContext;
<a class="jxr_linenumber" name="61" href="#61">61</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HttpExpectationVerifier;
<a class="jxr_linenumber" name="62" href="#62">62</a>  <strong class="jxr_keyword">import</strong> org.apache.http.protocol.HttpProcessor;
<a class="jxr_linenumber" name="63" href="#63">63</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.Args;
<a class="jxr_linenumber" name="64" href="#64">64</a>  <strong class="jxr_keyword">import</strong> org.apache.http.util.EncodingUtils;
<a class="jxr_linenumber" name="65" href="#65">65</a>  
<a class="jxr_linenumber" name="66" href="#66">66</a>  <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="67" href="#67">67</a>  <em class="jxr_javadoccomment"> * Fully asynchronous HTTP server side protocol handler implementation that</em>
<a class="jxr_linenumber" name="68" href="#68">68</a>  <em class="jxr_javadoccomment"> * implements the essential requirements of the HTTP protocol for the server</em>
<a class="jxr_linenumber" name="69" href="#69">69</a>  <em class="jxr_javadoccomment"> * side message processing as described by RFC 2616. It is capable of processing</em>
<a class="jxr_linenumber" name="70" href="#70">70</a>  <em class="jxr_javadoccomment"> * HTTP requests with nearly constant memory footprint. Only HTTP message heads</em>
<a class="jxr_linenumber" name="71" href="#71">71</a>  <em class="jxr_javadoccomment"> * are stored in memory, while content of message bodies is streamed directly</em>
<a class="jxr_linenumber" name="72" href="#72">72</a>  <em class="jxr_javadoccomment"> * from the entity to the underlying channel (and vice versa)</em>
<a class="jxr_linenumber" name="73" href="#73">73</a>  <em class="jxr_javadoccomment"> * {@link ConsumingNHttpEntity} and {@link ProducingNHttpEntity} interfaces.</em>
<a class="jxr_linenumber" name="74" href="#74">74</a>  <em class="jxr_javadoccomment"> * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="75" href="#75">75</a>  <em class="jxr_javadoccomment"> * When using this class, it is important to ensure that entities supplied for</em>
<a class="jxr_linenumber" name="76" href="#76">76</a>  <em class="jxr_javadoccomment"> * writing implement {@link ProducingNHttpEntity}. Doing so will allow the</em>
<a class="jxr_linenumber" name="77" href="#77">77</a>  <em class="jxr_javadoccomment"> * entity to be written out asynchronously. If entities supplied for writing do</em>
<a class="jxr_linenumber" name="78" href="#78">78</a>  <em class="jxr_javadoccomment"> * not implement {@link ProducingNHttpEntity}, a delegate is added that buffers</em>
<a class="jxr_linenumber" name="79" href="#79">79</a>  <em class="jxr_javadoccomment"> * the entire contents in memory. Additionally, the buffering might take place</em>
<a class="jxr_linenumber" name="80" href="#80">80</a>  <em class="jxr_javadoccomment"> * in the I/O thread, which could cause I/O to block temporarily. For best</em>
<a class="jxr_linenumber" name="81" href="#81">81</a>  <em class="jxr_javadoccomment"> * results, ensure that all entities set on {@link HttpResponse}s from</em>
<a class="jxr_linenumber" name="82" href="#82">82</a>  <em class="jxr_javadoccomment"> * {@link NHttpRequestHandler}s implement {@link ProducingNHttpEntity}.</em>
<a class="jxr_linenumber" name="83" href="#83">83</a>  <em class="jxr_javadoccomment"> * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="84" href="#84">84</a>  <em class="jxr_javadoccomment"> * If incoming requests enclose a content entity, {@link NHttpRequestHandler}s</em>
<a class="jxr_linenumber" name="85" href="#85">85</a>  <em class="jxr_javadoccomment"> * are expected to return a {@link ConsumingNHttpEntity} for reading the</em>
<a class="jxr_linenumber" name="86" href="#86">86</a>  <em class="jxr_javadoccomment"> * content. After the entity is finished reading the data,</em>
<a class="jxr_linenumber" name="87" href="#87">87</a>  <em class="jxr_javadoccomment"> * {@link NHttpRequestHandler#handle(HttpRequest, HttpResponse, NHttpResponseTrigger, HttpContext)}</em>
<a class="jxr_linenumber" name="88" href="#88">88</a>  <em class="jxr_javadoccomment"> * is called to generate a response.</em>
<a class="jxr_linenumber" name="89" href="#89">89</a>  <em class="jxr_javadoccomment"> * &lt;p/&gt;</em>
<a class="jxr_linenumber" name="90" href="#90">90</a>  <em class="jxr_javadoccomment"> * Individual {@link NHttpRequestHandler}s do not have to submit a response</em>
<a class="jxr_linenumber" name="91" href="#91">91</a>  <em class="jxr_javadoccomment"> * immediately. They can defer transmission of the HTTP response back to the</em>
<a class="jxr_linenumber" name="92" href="#92">92</a>  <em class="jxr_javadoccomment"> * client without blocking the I/O thread and to delegate the processing the</em>
<a class="jxr_linenumber" name="93" href="#93">93</a>  <em class="jxr_javadoccomment"> * HTTP request to a worker thread. The worker thread in its turn can use an</em>
<a class="jxr_linenumber" name="94" href="#94">94</a>  <em class="jxr_javadoccomment"> * instance of {@link NHttpResponseTrigger} passed as a parameter to submit</em>
<a class="jxr_linenumber" name="95" href="#95">95</a>  <em class="jxr_javadoccomment"> * a response as at a later point of time once the response becomes available.</em>
<a class="jxr_linenumber" name="96" href="#96">96</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="97" href="#97">97</a>  <em class="jxr_javadoccomment"> * @since 4.0</em>
<a class="jxr_linenumber" name="98" href="#98">98</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="99" href="#99">99</a>  <em class="jxr_javadoccomment"> * @deprecated (4.2) use {@link HttpAsyncService}</em>
<a class="jxr_linenumber" name="100" href="#100">100</a> <em class="jxr_javadoccomment"> */</em>
<a class="jxr_linenumber" name="101" href="#101">101</a> @Deprecated
<a class="jxr_linenumber" name="102" href="#102">102</a> @Immutable <em class="jxr_comment">// provided injected dependencies are immutable</em>
<a class="jxr_linenumber" name="103" href="#103">103</a> <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/nio/protocol/AsyncNHttpServiceHandler.html">AsyncNHttpServiceHandler</a> <strong class="jxr_keyword">extends</strong> <a href="../../../../../org/apache/http/nio/protocol/NHttpHandlerBase.html">NHttpHandlerBase</a>
<a class="jxr_linenumber" name="104" href="#104">104</a>                                       <strong class="jxr_keyword">implements</strong> <a href="../../../../../org/apache/http/nio/NHttpServiceHandler.html">NHttpServiceHandler</a> {
<a class="jxr_linenumber" name="105" href="#105">105</a> 
<a class="jxr_linenumber" name="106" href="#106">106</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">final</strong> HttpResponseFactory responseFactory;
<a class="jxr_linenumber" name="107" href="#107">107</a> 
<a class="jxr_linenumber" name="108" href="#108">108</a>     <strong class="jxr_keyword">protected</strong> <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandlerResolver.html">NHttpRequestHandlerResolver</a> handlerResolver;
<a class="jxr_linenumber" name="109" href="#109">109</a>     <strong class="jxr_keyword">protected</strong> HttpExpectationVerifier expectationVerifier;
<a class="jxr_linenumber" name="110" href="#110">110</a> 
<a class="jxr_linenumber" name="111" href="#111">111</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/nio/protocol/AsyncNHttpServiceHandler.html">AsyncNHttpServiceHandler</a>(
<a class="jxr_linenumber" name="112" href="#112">112</a>             <strong class="jxr_keyword">final</strong> HttpProcessor httpProcessor,
<a class="jxr_linenumber" name="113" href="#113">113</a>             <strong class="jxr_keyword">final</strong> HttpResponseFactory responseFactory,
<a class="jxr_linenumber" name="114" href="#114">114</a>             <strong class="jxr_keyword">final</strong> ConnectionReuseStrategy connStrategy,
<a class="jxr_linenumber" name="115" href="#115">115</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/util/ByteBufferAllocator.html">ByteBufferAllocator</a> allocator,
<a class="jxr_linenumber" name="116" href="#116">116</a>             <strong class="jxr_keyword">final</strong> HttpParams params) {
<a class="jxr_linenumber" name="117" href="#117">117</a>         <strong class="jxr_keyword">super</strong>(httpProcessor, connStrategy, allocator, params);
<a class="jxr_linenumber" name="118" href="#118">118</a>         Args.notNull(responseFactory, <span class="jxr_string">"Response factory"</span>);
<a class="jxr_linenumber" name="119" href="#119">119</a>         <strong class="jxr_keyword">this</strong>.responseFactory = responseFactory;
<a class="jxr_linenumber" name="120" href="#120">120</a>     }
<a class="jxr_linenumber" name="121" href="#121">121</a> 
<a class="jxr_linenumber" name="122" href="#122">122</a>     <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/nio/protocol/AsyncNHttpServiceHandler.html">AsyncNHttpServiceHandler</a>(
<a class="jxr_linenumber" name="123" href="#123">123</a>             <strong class="jxr_keyword">final</strong> HttpProcessor httpProcessor,
<a class="jxr_linenumber" name="124" href="#124">124</a>             <strong class="jxr_keyword">final</strong> HttpResponseFactory responseFactory,
<a class="jxr_linenumber" name="125" href="#125">125</a>             <strong class="jxr_keyword">final</strong> ConnectionReuseStrategy connStrategy,
<a class="jxr_linenumber" name="126" href="#126">126</a>             <strong class="jxr_keyword">final</strong> HttpParams params) {
<a class="jxr_linenumber" name="127" href="#127">127</a>         <strong class="jxr_keyword">this</strong>(httpProcessor, responseFactory, connStrategy, HeapByteBufferAllocator.INSTANCE, params);
<a class="jxr_linenumber" name="128" href="#128">128</a>     }
<a class="jxr_linenumber" name="129" href="#129">129</a> 
<a class="jxr_linenumber" name="130" href="#130">130</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setExpectationVerifier(<strong class="jxr_keyword">final</strong> HttpExpectationVerifier expectationVerifier) {
<a class="jxr_linenumber" name="131" href="#131">131</a>         <strong class="jxr_keyword">this</strong>.expectationVerifier = expectationVerifier;
<a class="jxr_linenumber" name="132" href="#132">132</a>     }
<a class="jxr_linenumber" name="133" href="#133">133</a> 
<a class="jxr_linenumber" name="134" href="#134">134</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setHandlerResolver(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandlerResolver.html">NHttpRequestHandlerResolver</a> handlerResolver) {
<a class="jxr_linenumber" name="135" href="#135">135</a>         <strong class="jxr_keyword">this</strong>.handlerResolver = handlerResolver;
<a class="jxr_linenumber" name="136" href="#136">136</a>     }
<a class="jxr_linenumber" name="137" href="#137">137</a> 
<a class="jxr_linenumber" name="138" href="#138">138</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> connected(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn) {
<a class="jxr_linenumber" name="139" href="#139">139</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="140" href="#140">140</a> 
<a class="jxr_linenumber" name="141" href="#141">141</a>         <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a>();
<a class="jxr_linenumber" name="142" href="#142">142</a>         context.setAttribute(CONN_STATE, connState);
<a class="jxr_linenumber" name="143" href="#143">143</a>         context.setAttribute(ExecutionContext.HTTP_CONNECTION, conn);
<a class="jxr_linenumber" name="144" href="#144">144</a> 
<a class="jxr_linenumber" name="145" href="#145">145</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="146" href="#146">146</a>             <strong class="jxr_keyword">this</strong>.eventListener.connectionOpen(conn);
<a class="jxr_linenumber" name="147" href="#147">147</a>         }
<a class="jxr_linenumber" name="148" href="#148">148</a>     }
<a class="jxr_linenumber" name="149" href="#149">149</a> 
<a class="jxr_linenumber" name="150" href="#150">150</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> requestReceived(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn) {
<a class="jxr_linenumber" name="151" href="#151">151</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="152" href="#152">152</a> 
<a class="jxr_linenumber" name="153" href="#153">153</a>         <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState = (ServerConnState) context.getAttribute(CONN_STATE);
<a class="jxr_linenumber" name="154" href="#154">154</a> 
<a class="jxr_linenumber" name="155" href="#155">155</a>         HttpRequest request = conn.getHttpRequest();
<a class="jxr_linenumber" name="156" href="#156">156</a>         request.setParams(<strong class="jxr_keyword">new</strong> DefaultedHttpParams(request.getParams(), <strong class="jxr_keyword">this</strong>.params));
<a class="jxr_linenumber" name="157" href="#157">157</a> 
<a class="jxr_linenumber" name="158" href="#158">158</a>         connState.setRequest(request);
<a class="jxr_linenumber" name="159" href="#159">159</a> 
<a class="jxr_linenumber" name="160" href="#160">160</a>         <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandler.html">NHttpRequestHandler</a> requestHandler = getRequestHandler(request);
<a class="jxr_linenumber" name="161" href="#161">161</a>         connState.setRequestHandler(requestHandler);
<a class="jxr_linenumber" name="162" href="#162">162</a> 
<a class="jxr_linenumber" name="163" href="#163">163</a>         ProtocolVersion ver = request.getRequestLine().getProtocolVersion();
<a class="jxr_linenumber" name="164" href="#164">164</a>         <strong class="jxr_keyword">if</strong> (!ver.lessEquals(HttpVersion.HTTP_1_1)) {
<a class="jxr_linenumber" name="165" href="#165">165</a>             <em class="jxr_comment">// Downgrade protocol version if greater than HTTP/1.1</em>
<a class="jxr_linenumber" name="166" href="#166">166</a>             ver = HttpVersion.HTTP_1_1;
<a class="jxr_linenumber" name="167" href="#167">167</a>         }
<a class="jxr_linenumber" name="168" href="#168">168</a> 
<a class="jxr_linenumber" name="169" href="#169">169</a>         HttpResponse response;
<a class="jxr_linenumber" name="170" href="#170">170</a> 
<a class="jxr_linenumber" name="171" href="#171">171</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="172" href="#172">172</a> 
<a class="jxr_linenumber" name="173" href="#173">173</a>             <strong class="jxr_keyword">if</strong> (request instanceof HttpEntityEnclosingRequest) {
<a class="jxr_linenumber" name="174" href="#174">174</a>                 HttpEntityEnclosingRequest entityRequest = (HttpEntityEnclosingRequest) request;
<a class="jxr_linenumber" name="175" href="#175">175</a>                 <strong class="jxr_keyword">if</strong> (entityRequest.expectContinue()) {
<a class="jxr_linenumber" name="176" href="#176">176</a>                     response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(
<a class="jxr_linenumber" name="177" href="#177">177</a>                             ver, HttpStatus.SC_CONTINUE, context);
<a class="jxr_linenumber" name="178" href="#178">178</a>                     response.setParams(
<a class="jxr_linenumber" name="179" href="#179">179</a>                             <strong class="jxr_keyword">new</strong> DefaultedHttpParams(response.getParams(), <strong class="jxr_keyword">this</strong>.params));
<a class="jxr_linenumber" name="180" href="#180">180</a> 
<a class="jxr_linenumber" name="181" href="#181">181</a>                     <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.expectationVerifier != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="182" href="#182">182</a>                         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="183" href="#183">183</a>                             <strong class="jxr_keyword">this</strong>.expectationVerifier.verify(request, response, context);
<a class="jxr_linenumber" name="184" href="#184">184</a>                         } <strong class="jxr_keyword">catch</strong> (HttpException ex) {
<a class="jxr_linenumber" name="185" href="#185">185</a>                             response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(
<a class="jxr_linenumber" name="186" href="#186">186</a>                                     HttpVersion.HTTP_1_0,
<a class="jxr_linenumber" name="187" href="#187">187</a>                                     HttpStatus.SC_INTERNAL_SERVER_ERROR,
<a class="jxr_linenumber" name="188" href="#188">188</a>                                     context);
<a class="jxr_linenumber" name="189" href="#189">189</a>                             response.setParams(
<a class="jxr_linenumber" name="190" href="#190">190</a>                                     <strong class="jxr_keyword">new</strong> DefaultedHttpParams(response.getParams(), <strong class="jxr_keyword">this</strong>.params));
<a class="jxr_linenumber" name="191" href="#191">191</a>                             handleException(ex, response);
<a class="jxr_linenumber" name="192" href="#192">192</a>                         }
<a class="jxr_linenumber" name="193" href="#193">193</a>                     }
<a class="jxr_linenumber" name="194" href="#194">194</a> 
<a class="jxr_linenumber" name="195" href="#195">195</a>                     <strong class="jxr_keyword">if</strong> (response.getStatusLine().getStatusCode() &lt; 200) {
<a class="jxr_linenumber" name="196" href="#196">196</a>                         <em class="jxr_comment">// Send 1xx response indicating the server expections</em>
<a class="jxr_linenumber" name="197" href="#197">197</a>                         <em class="jxr_comment">// have been met</em>
<a class="jxr_linenumber" name="198" href="#198">198</a>                         conn.submitResponse(response);
<a class="jxr_linenumber" name="199" href="#199">199</a>                     } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="200" href="#200">200</a>                         conn.resetInput();
<a class="jxr_linenumber" name="201" href="#201">201</a>                         sendResponse(conn, request, response);
<a class="jxr_linenumber" name="202" href="#202">202</a>                     }
<a class="jxr_linenumber" name="203" href="#203">203</a>                 }
<a class="jxr_linenumber" name="204" href="#204">204</a>                 <em class="jxr_comment">// Request content is expected.</em>
<a class="jxr_linenumber" name="205" href="#205">205</a>                 <a href="../../../../../org/apache/http/nio/entity/ConsumingNHttpEntity.html">ConsumingNHttpEntity</a> consumingEntity = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="206" href="#206">206</a> 
<a class="jxr_linenumber" name="207" href="#207">207</a>                 <em class="jxr_comment">// Lookup request handler for this request</em>
<a class="jxr_linenumber" name="208" href="#208">208</a>                 <strong class="jxr_keyword">if</strong> (requestHandler != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="209" href="#209">209</a>                     consumingEntity = requestHandler.entityRequest(entityRequest, context);
<a class="jxr_linenumber" name="210" href="#210">210</a>                 }
<a class="jxr_linenumber" name="211" href="#211">211</a>                 <strong class="jxr_keyword">if</strong> (consumingEntity == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="212" href="#212">212</a>                     consumingEntity = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/nio/protocol/NullNHttpEntity.html">NullNHttpEntity</a>(entityRequest.getEntity());
<a class="jxr_linenumber" name="213" href="#213">213</a>                 }
<a class="jxr_linenumber" name="214" href="#214">214</a>                 entityRequest.setEntity(consumingEntity);
<a class="jxr_linenumber" name="215" href="#215">215</a>                 connState.setConsumingEntity(consumingEntity);
<a class="jxr_linenumber" name="216" href="#216">216</a> 
<a class="jxr_linenumber" name="217" href="#217">217</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="218" href="#218">218</a>                 <em class="jxr_comment">// No request content is expected.</em>
<a class="jxr_linenumber" name="219" href="#219">219</a>                 <em class="jxr_comment">// Process request right away</em>
<a class="jxr_linenumber" name="220" href="#220">220</a>                 conn.suspendInput();
<a class="jxr_linenumber" name="221" href="#221">221</a>                 processRequest(conn, request);
<a class="jxr_linenumber" name="222" href="#222">222</a>             }
<a class="jxr_linenumber" name="223" href="#223">223</a> 
<a class="jxr_linenumber" name="224" href="#224">224</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="225" href="#225">225</a>             shutdownConnection(conn, ex);
<a class="jxr_linenumber" name="226" href="#226">226</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="227" href="#227">227</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalIOException(ex, conn);
<a class="jxr_linenumber" name="228" href="#228">228</a>             }
<a class="jxr_linenumber" name="229" href="#229">229</a>         } <strong class="jxr_keyword">catch</strong> (HttpException ex) {
<a class="jxr_linenumber" name="230" href="#230">230</a>             closeConnection(conn, ex);
<a class="jxr_linenumber" name="231" href="#231">231</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="232" href="#232">232</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalProtocolException(ex, conn);
<a class="jxr_linenumber" name="233" href="#233">233</a>             }
<a class="jxr_linenumber" name="234" href="#234">234</a>         }
<a class="jxr_linenumber" name="235" href="#235">235</a> 
<a class="jxr_linenumber" name="236" href="#236">236</a>     }
<a class="jxr_linenumber" name="237" href="#237">237</a> 
<a class="jxr_linenumber" name="238" href="#238">238</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> closed(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn) {
<a class="jxr_linenumber" name="239" href="#239">239</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="240" href="#240">240</a> 
<a class="jxr_linenumber" name="241" href="#241">241</a>         <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState = (ServerConnState) context.getAttribute(CONN_STATE);
<a class="jxr_linenumber" name="242" href="#242">242</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="243" href="#243">243</a>             connState.reset();
<a class="jxr_linenumber" name="244" href="#244">244</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="245" href="#245">245</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="246" href="#246">246</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalIOException(ex, conn);
<a class="jxr_linenumber" name="247" href="#247">247</a>             }
<a class="jxr_linenumber" name="248" href="#248">248</a>         }
<a class="jxr_linenumber" name="249" href="#249">249</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="250" href="#250">250</a>             <strong class="jxr_keyword">this</strong>.eventListener.connectionClosed(conn);
<a class="jxr_linenumber" name="251" href="#251">251</a>         }
<a class="jxr_linenumber" name="252" href="#252">252</a>     }
<a class="jxr_linenumber" name="253" href="#253">253</a> 
<a class="jxr_linenumber" name="254" href="#254">254</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> exception(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn, <strong class="jxr_keyword">final</strong> HttpException httpex) {
<a class="jxr_linenumber" name="255" href="#255">255</a>         <strong class="jxr_keyword">if</strong> (conn.isResponseSubmitted()) {
<a class="jxr_linenumber" name="256" href="#256">256</a>             <em class="jxr_comment">// There is not much that we can do if a response head</em>
<a class="jxr_linenumber" name="257" href="#257">257</a>             <em class="jxr_comment">// has already been submitted</em>
<a class="jxr_linenumber" name="258" href="#258">258</a>             closeConnection(conn, httpex);
<a class="jxr_linenumber" name="259" href="#259">259</a>             <strong class="jxr_keyword">if</strong> (eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="260" href="#260">260</a>                 eventListener.fatalProtocolException(httpex, conn);
<a class="jxr_linenumber" name="261" href="#261">261</a>             }
<a class="jxr_linenumber" name="262" href="#262">262</a>             <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="263" href="#263">263</a>         }
<a class="jxr_linenumber" name="264" href="#264">264</a> 
<a class="jxr_linenumber" name="265" href="#265">265</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="266" href="#266">266</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="267" href="#267">267</a>             HttpResponse response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(
<a class="jxr_linenumber" name="268" href="#268">268</a>                     HttpVersion.HTTP_1_0, HttpStatus.SC_INTERNAL_SERVER_ERROR, context);
<a class="jxr_linenumber" name="269" href="#269">269</a>             response.setParams(
<a class="jxr_linenumber" name="270" href="#270">270</a>                     <strong class="jxr_keyword">new</strong> DefaultedHttpParams(response.getParams(), <strong class="jxr_keyword">this</strong>.params));
<a class="jxr_linenumber" name="271" href="#271">271</a>             handleException(httpex, response);
<a class="jxr_linenumber" name="272" href="#272">272</a>             response.setEntity(<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="273" href="#273">273</a>             sendResponse(conn, <strong class="jxr_keyword">null</strong>, response);
<a class="jxr_linenumber" name="274" href="#274">274</a> 
<a class="jxr_linenumber" name="275" href="#275">275</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="276" href="#276">276</a>             shutdownConnection(conn, ex);
<a class="jxr_linenumber" name="277" href="#277">277</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="278" href="#278">278</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalIOException(ex, conn);
<a class="jxr_linenumber" name="279" href="#279">279</a>             }
<a class="jxr_linenumber" name="280" href="#280">280</a>         } <strong class="jxr_keyword">catch</strong> (HttpException ex) {
<a class="jxr_linenumber" name="281" href="#281">281</a>             closeConnection(conn, ex);
<a class="jxr_linenumber" name="282" href="#282">282</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="283" href="#283">283</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalProtocolException(ex, conn);
<a class="jxr_linenumber" name="284" href="#284">284</a>             }
<a class="jxr_linenumber" name="285" href="#285">285</a>         }
<a class="jxr_linenumber" name="286" href="#286">286</a>     }
<a class="jxr_linenumber" name="287" href="#287">287</a> 
<a class="jxr_linenumber" name="288" href="#288">288</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> exception(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn, <strong class="jxr_keyword">final</strong> IOException ex) {
<a class="jxr_linenumber" name="289" href="#289">289</a>         shutdownConnection(conn, ex);
<a class="jxr_linenumber" name="290" href="#290">290</a> 
<a class="jxr_linenumber" name="291" href="#291">291</a>         <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="292" href="#292">292</a>             <strong class="jxr_keyword">this</strong>.eventListener.fatalIOException(ex, conn);
<a class="jxr_linenumber" name="293" href="#293">293</a>         }
<a class="jxr_linenumber" name="294" href="#294">294</a>     }
<a class="jxr_linenumber" name="295" href="#295">295</a> 
<a class="jxr_linenumber" name="296" href="#296">296</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> timeout(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn) {
<a class="jxr_linenumber" name="297" href="#297">297</a>         handleTimeout(conn);
<a class="jxr_linenumber" name="298" href="#298">298</a>     }
<a class="jxr_linenumber" name="299" href="#299">299</a> 
<a class="jxr_linenumber" name="300" href="#300">300</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> inputReady(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn, <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/ContentDecoder.html">ContentDecoder</a> decoder) {
<a class="jxr_linenumber" name="301" href="#301">301</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="302" href="#302">302</a>         <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState = (ServerConnState) context.getAttribute(CONN_STATE);
<a class="jxr_linenumber" name="303" href="#303">303</a> 
<a class="jxr_linenumber" name="304" href="#304">304</a>         HttpRequest request = connState.getRequest();
<a class="jxr_linenumber" name="305" href="#305">305</a>         <a href="../../../../../org/apache/http/nio/entity/ConsumingNHttpEntity.html">ConsumingNHttpEntity</a> consumingEntity = connState.getConsumingEntity();
<a class="jxr_linenumber" name="306" href="#306">306</a> 
<a class="jxr_linenumber" name="307" href="#307">307</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="308" href="#308">308</a> 
<a class="jxr_linenumber" name="309" href="#309">309</a>             consumingEntity.consumeContent(decoder, conn);
<a class="jxr_linenumber" name="310" href="#310">310</a>             <strong class="jxr_keyword">if</strong> (decoder.isCompleted()) {
<a class="jxr_linenumber" name="311" href="#311">311</a>                 conn.suspendInput();
<a class="jxr_linenumber" name="312" href="#312">312</a>                 processRequest(conn, request);
<a class="jxr_linenumber" name="313" href="#313">313</a>             }
<a class="jxr_linenumber" name="314" href="#314">314</a> 
<a class="jxr_linenumber" name="315" href="#315">315</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="316" href="#316">316</a>             shutdownConnection(conn, ex);
<a class="jxr_linenumber" name="317" href="#317">317</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="318" href="#318">318</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalIOException(ex, conn);
<a class="jxr_linenumber" name="319" href="#319">319</a>             }
<a class="jxr_linenumber" name="320" href="#320">320</a>         } <strong class="jxr_keyword">catch</strong> (HttpException ex) {
<a class="jxr_linenumber" name="321" href="#321">321</a>             closeConnection(conn, ex);
<a class="jxr_linenumber" name="322" href="#322">322</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="323" href="#323">323</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalProtocolException(ex, conn);
<a class="jxr_linenumber" name="324" href="#324">324</a>             }
<a class="jxr_linenumber" name="325" href="#325">325</a>         }
<a class="jxr_linenumber" name="326" href="#326">326</a>     }
<a class="jxr_linenumber" name="327" href="#327">327</a> 
<a class="jxr_linenumber" name="328" href="#328">328</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> responseReady(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn) {
<a class="jxr_linenumber" name="329" href="#329">329</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="330" href="#330">330</a>         <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState = (ServerConnState) context.getAttribute(CONN_STATE);
<a class="jxr_linenumber" name="331" href="#331">331</a> 
<a class="jxr_linenumber" name="332" href="#332">332</a>         <strong class="jxr_keyword">if</strong> (connState.isHandled()) {
<a class="jxr_linenumber" name="333" href="#333">333</a>             <strong class="jxr_keyword">return</strong>;
<a class="jxr_linenumber" name="334" href="#334">334</a>         }
<a class="jxr_linenumber" name="335" href="#335">335</a> 
<a class="jxr_linenumber" name="336" href="#336">336</a>         HttpRequest request = connState.getRequest();
<a class="jxr_linenumber" name="337" href="#337">337</a> 
<a class="jxr_linenumber" name="338" href="#338">338</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="339" href="#339">339</a> 
<a class="jxr_linenumber" name="340" href="#340">340</a>             IOException ioex = connState.getIOException();
<a class="jxr_linenumber" name="341" href="#341">341</a>             <strong class="jxr_keyword">if</strong> (ioex != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="342" href="#342">342</a>                 <strong class="jxr_keyword">throw</strong> ioex;
<a class="jxr_linenumber" name="343" href="#343">343</a>             }
<a class="jxr_linenumber" name="344" href="#344">344</a> 
<a class="jxr_linenumber" name="345" href="#345">345</a>             HttpException httpex = connState.getHttpException();
<a class="jxr_linenumber" name="346" href="#346">346</a>             <strong class="jxr_keyword">if</strong> (httpex != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="347" href="#347">347</a>                 HttpResponse response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(HttpVersion.HTTP_1_0,
<a class="jxr_linenumber" name="348" href="#348">348</a>                         HttpStatus.SC_INTERNAL_SERVER_ERROR, context);
<a class="jxr_linenumber" name="349" href="#349">349</a>                 response.setParams(
<a class="jxr_linenumber" name="350" href="#350">350</a>                         <strong class="jxr_keyword">new</strong> DefaultedHttpParams(response.getParams(), <strong class="jxr_keyword">this</strong>.params));
<a class="jxr_linenumber" name="351" href="#351">351</a>                 handleException(httpex, response);
<a class="jxr_linenumber" name="352" href="#352">352</a>                 connState.setResponse(response);
<a class="jxr_linenumber" name="353" href="#353">353</a>             }
<a class="jxr_linenumber" name="354" href="#354">354</a> 
<a class="jxr_linenumber" name="355" href="#355">355</a>             HttpResponse response = connState.getResponse();
<a class="jxr_linenumber" name="356" href="#356">356</a>             <strong class="jxr_keyword">if</strong> (response != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="357" href="#357">357</a>                 connState.setHandled(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="358" href="#358">358</a>                 sendResponse(conn, request, response);
<a class="jxr_linenumber" name="359" href="#359">359</a>             }
<a class="jxr_linenumber" name="360" href="#360">360</a> 
<a class="jxr_linenumber" name="361" href="#361">361</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="362" href="#362">362</a>             shutdownConnection(conn, ex);
<a class="jxr_linenumber" name="363" href="#363">363</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="364" href="#364">364</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalIOException(ex, conn);
<a class="jxr_linenumber" name="365" href="#365">365</a>             }
<a class="jxr_linenumber" name="366" href="#366">366</a>         } <strong class="jxr_keyword">catch</strong> (HttpException ex) {
<a class="jxr_linenumber" name="367" href="#367">367</a>             closeConnection(conn, ex);
<a class="jxr_linenumber" name="368" href="#368">368</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="369" href="#369">369</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalProtocolException(ex, conn);
<a class="jxr_linenumber" name="370" href="#370">370</a>             }
<a class="jxr_linenumber" name="371" href="#371">371</a>         }
<a class="jxr_linenumber" name="372" href="#372">372</a>     }
<a class="jxr_linenumber" name="373" href="#373">373</a> 
<a class="jxr_linenumber" name="374" href="#374">374</a>     <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> outputReady(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn, <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/ContentEncoder.html">ContentEncoder</a> encoder) {
<a class="jxr_linenumber" name="375" href="#375">375</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="376" href="#376">376</a>         <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState = (ServerConnState) context.getAttribute(CONN_STATE);
<a class="jxr_linenumber" name="377" href="#377">377</a> 
<a class="jxr_linenumber" name="378" href="#378">378</a>         HttpResponse response = conn.getHttpResponse();
<a class="jxr_linenumber" name="379" href="#379">379</a> 
<a class="jxr_linenumber" name="380" href="#380">380</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="381" href="#381">381</a>             <a href="../../../../../org/apache/http/nio/entity/ProducingNHttpEntity.html">ProducingNHttpEntity</a> entity = connState.getProducingEntity();
<a class="jxr_linenumber" name="382" href="#382">382</a>             entity.produceContent(encoder, conn);
<a class="jxr_linenumber" name="383" href="#383">383</a> 
<a class="jxr_linenumber" name="384" href="#384">384</a>             <strong class="jxr_keyword">if</strong> (encoder.isCompleted()) {
<a class="jxr_linenumber" name="385" href="#385">385</a>                 connState.finishOutput();
<a class="jxr_linenumber" name="386" href="#386">386</a>                 <strong class="jxr_keyword">if</strong> (!<strong class="jxr_keyword">this</strong>.connStrategy.keepAlive(response, context)) {
<a class="jxr_linenumber" name="387" href="#387">387</a>                     conn.close();
<a class="jxr_linenumber" name="388" href="#388">388</a>                 } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="389" href="#389">389</a>                     <em class="jxr_comment">// Ready to process new request</em>
<a class="jxr_linenumber" name="390" href="#390">390</a>                     connState.reset();
<a class="jxr_linenumber" name="391" href="#391">391</a>                     conn.requestInput();
<a class="jxr_linenumber" name="392" href="#392">392</a>                 }
<a class="jxr_linenumber" name="393" href="#393">393</a>                 responseComplete(response, context);
<a class="jxr_linenumber" name="394" href="#394">394</a>             }
<a class="jxr_linenumber" name="395" href="#395">395</a> 
<a class="jxr_linenumber" name="396" href="#396">396</a>         } <strong class="jxr_keyword">catch</strong> (IOException ex) {
<a class="jxr_linenumber" name="397" href="#397">397</a>             shutdownConnection(conn, ex);
<a class="jxr_linenumber" name="398" href="#398">398</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.eventListener != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="399" href="#399">399</a>                 <strong class="jxr_keyword">this</strong>.eventListener.fatalIOException(ex, conn);
<a class="jxr_linenumber" name="400" href="#400">400</a>             }
<a class="jxr_linenumber" name="401" href="#401">401</a>         }
<a class="jxr_linenumber" name="402" href="#402">402</a>     }
<a class="jxr_linenumber" name="403" href="#403">403</a> 
<a class="jxr_linenumber" name="404" href="#404">404</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> handleException(<strong class="jxr_keyword">final</strong> HttpException ex, <strong class="jxr_keyword">final</strong> HttpResponse response) {
<a class="jxr_linenumber" name="405" href="#405">405</a>         <strong class="jxr_keyword">int</strong> code = HttpStatus.SC_INTERNAL_SERVER_ERROR;
<a class="jxr_linenumber" name="406" href="#406">406</a>         <strong class="jxr_keyword">if</strong> (ex instanceof MethodNotSupportedException) {
<a class="jxr_linenumber" name="407" href="#407">407</a>             code = HttpStatus.SC_NOT_IMPLEMENTED;
<a class="jxr_linenumber" name="408" href="#408">408</a>         } <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ex instanceof UnsupportedHttpVersionException) {
<a class="jxr_linenumber" name="409" href="#409">409</a>             code = HttpStatus.SC_HTTP_VERSION_NOT_SUPPORTED;
<a class="jxr_linenumber" name="410" href="#410">410</a>         } <strong class="jxr_keyword">else</strong> <strong class="jxr_keyword">if</strong> (ex instanceof ProtocolException) {
<a class="jxr_linenumber" name="411" href="#411">411</a>             code = HttpStatus.SC_BAD_REQUEST;
<a class="jxr_linenumber" name="412" href="#412">412</a>         }
<a class="jxr_linenumber" name="413" href="#413">413</a>         response.setStatusCode(code);
<a class="jxr_linenumber" name="414" href="#414">414</a> 
<a class="jxr_linenumber" name="415" href="#415">415</a>         byte[] msg = EncodingUtils.getAsciiBytes(ex.getMessage());
<a class="jxr_linenumber" name="416" href="#416">416</a>         <a href="../../../../../org/apache/http/nio/entity/NByteArrayEntity.html">NByteArrayEntity</a> entity = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/nio/entity/NByteArrayEntity.html">NByteArrayEntity</a>(msg);
<a class="jxr_linenumber" name="417" href="#417">417</a>         entity.setContentType(<span class="jxr_string">"text/plain; charset=US-ASCII"</span>);
<a class="jxr_linenumber" name="418" href="#418">418</a>         response.setEntity(entity);
<a class="jxr_linenumber" name="419" href="#419">419</a>     }
<a class="jxr_linenumber" name="420" href="#420">420</a> 
<a class="jxr_linenumber" name="421" href="#421">421</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="422" href="#422">422</a> <em class="jxr_javadoccomment">     * @throws HttpException - not thrown currently</em>
<a class="jxr_linenumber" name="423" href="#423">423</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="424" href="#424">424</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> processRequest(
<a class="jxr_linenumber" name="425" href="#425">425</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn,
<a class="jxr_linenumber" name="426" href="#426">426</a>             <strong class="jxr_keyword">final</strong> HttpRequest request) <strong class="jxr_keyword">throws</strong> IOException, HttpException {
<a class="jxr_linenumber" name="427" href="#427">427</a> 
<a class="jxr_linenumber" name="428" href="#428">428</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="429" href="#429">429</a>         <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState = (ServerConnState) context.getAttribute(CONN_STATE);
<a class="jxr_linenumber" name="430" href="#430">430</a> 
<a class="jxr_linenumber" name="431" href="#431">431</a>         ProtocolVersion ver = request.getRequestLine().getProtocolVersion();
<a class="jxr_linenumber" name="432" href="#432">432</a> 
<a class="jxr_linenumber" name="433" href="#433">433</a>         <strong class="jxr_keyword">if</strong> (!ver.lessEquals(HttpVersion.HTTP_1_1)) {
<a class="jxr_linenumber" name="434" href="#434">434</a>             <em class="jxr_comment">// Downgrade protocol version if greater than HTTP/1.1</em>
<a class="jxr_linenumber" name="435" href="#435">435</a>             ver = HttpVersion.HTTP_1_1;
<a class="jxr_linenumber" name="436" href="#436">436</a>         }
<a class="jxr_linenumber" name="437" href="#437">437</a> 
<a class="jxr_linenumber" name="438" href="#438">438</a>         <a href="../../../../../org/apache/http/nio/protocol/NHttpResponseTrigger.html">NHttpResponseTrigger</a> trigger = <strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/nio/protocol/AsyncNHttpServiceHandler.html">ResponseTriggerImpl</a>(connState, conn);
<a class="jxr_linenumber" name="439" href="#439">439</a>         <strong class="jxr_keyword">try</strong> {
<a class="jxr_linenumber" name="440" href="#440">440</a>             <strong class="jxr_keyword">this</strong>.httpProcessor.process(request, context);
<a class="jxr_linenumber" name="441" href="#441">441</a> 
<a class="jxr_linenumber" name="442" href="#442">442</a>             <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandler.html">NHttpRequestHandler</a> handler = connState.getRequestHandler();
<a class="jxr_linenumber" name="443" href="#443">443</a>             <strong class="jxr_keyword">if</strong> (handler != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="444" href="#444">444</a>                 HttpResponse response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(
<a class="jxr_linenumber" name="445" href="#445">445</a>                         ver, HttpStatus.SC_OK, context);
<a class="jxr_linenumber" name="446" href="#446">446</a>                 response.setParams(
<a class="jxr_linenumber" name="447" href="#447">447</a>                         <strong class="jxr_keyword">new</strong> DefaultedHttpParams(response.getParams(), <strong class="jxr_keyword">this</strong>.params));
<a class="jxr_linenumber" name="448" href="#448">448</a> 
<a class="jxr_linenumber" name="449" href="#449">449</a>                 handler.handle(
<a class="jxr_linenumber" name="450" href="#450">450</a>                         request,
<a class="jxr_linenumber" name="451" href="#451">451</a>                         response,
<a class="jxr_linenumber" name="452" href="#452">452</a>                         trigger,
<a class="jxr_linenumber" name="453" href="#453">453</a>                         context);
<a class="jxr_linenumber" name="454" href="#454">454</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="455" href="#455">455</a>                 HttpResponse response = <strong class="jxr_keyword">this</strong>.responseFactory.newHttpResponse(ver,
<a class="jxr_linenumber" name="456" href="#456">456</a>                         HttpStatus.SC_NOT_IMPLEMENTED, context);
<a class="jxr_linenumber" name="457" href="#457">457</a>                 response.setParams(
<a class="jxr_linenumber" name="458" href="#458">458</a>                         <strong class="jxr_keyword">new</strong> DefaultedHttpParams(response.getParams(), <strong class="jxr_keyword">this</strong>.params));
<a class="jxr_linenumber" name="459" href="#459">459</a>                 trigger.submitResponse(response);
<a class="jxr_linenumber" name="460" href="#460">460</a>             }
<a class="jxr_linenumber" name="461" href="#461">461</a> 
<a class="jxr_linenumber" name="462" href="#462">462</a>         } <strong class="jxr_keyword">catch</strong> (HttpException ex) {
<a class="jxr_linenumber" name="463" href="#463">463</a>             trigger.handleException(ex);
<a class="jxr_linenumber" name="464" href="#464">464</a>         }
<a class="jxr_linenumber" name="465" href="#465">465</a>     }
<a class="jxr_linenumber" name="466" href="#466">466</a> 
<a class="jxr_linenumber" name="467" href="#467">467</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">void</strong> sendResponse(
<a class="jxr_linenumber" name="468" href="#468">468</a>             <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/NHttpServerConnection.html">NHttpServerConnection</a> conn,
<a class="jxr_linenumber" name="469" href="#469">469</a>             <strong class="jxr_keyword">final</strong> HttpRequest request,
<a class="jxr_linenumber" name="470" href="#470">470</a>             <strong class="jxr_keyword">final</strong> HttpResponse response) <strong class="jxr_keyword">throws</strong> IOException, HttpException {
<a class="jxr_linenumber" name="471" href="#471">471</a>         HttpContext context = conn.getContext();
<a class="jxr_linenumber" name="472" href="#472">472</a>         <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState = (ServerConnState) context.getAttribute(CONN_STATE);
<a class="jxr_linenumber" name="473" href="#473">473</a> 
<a class="jxr_linenumber" name="474" href="#474">474</a>         <em class="jxr_comment">// Now that a response is ready, we can cleanup the listener for the request.</em>
<a class="jxr_linenumber" name="475" href="#475">475</a>         connState.finishInput();
<a class="jxr_linenumber" name="476" href="#476">476</a> 
<a class="jxr_linenumber" name="477" href="#477">477</a>         <em class="jxr_comment">// Some processers need the request that generated this response.</em>
<a class="jxr_linenumber" name="478" href="#478">478</a>         context.setAttribute(ExecutionContext.HTTP_REQUEST, request);
<a class="jxr_linenumber" name="479" href="#479">479</a>         <strong class="jxr_keyword">this</strong>.httpProcessor.process(response, context);
<a class="jxr_linenumber" name="480" href="#480">480</a>         context.setAttribute(ExecutionContext.HTTP_REQUEST, <strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="481" href="#481">481</a> 
<a class="jxr_linenumber" name="482" href="#482">482</a>         <strong class="jxr_keyword">if</strong> (response.getEntity() != <strong class="jxr_keyword">null</strong> &amp;&amp; !canResponseHaveBody(request, response)) {
<a class="jxr_linenumber" name="483" href="#483">483</a>             response.setEntity(<strong class="jxr_keyword">null</strong>);
<a class="jxr_linenumber" name="484" href="#484">484</a>         }
<a class="jxr_linenumber" name="485" href="#485">485</a> 
<a class="jxr_linenumber" name="486" href="#486">486</a>         HttpEntity entity = response.getEntity();
<a class="jxr_linenumber" name="487" href="#487">487</a>         <strong class="jxr_keyword">if</strong> (entity != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="488" href="#488">488</a>             <strong class="jxr_keyword">if</strong> (entity instanceof ProducingNHttpEntity) {
<a class="jxr_linenumber" name="489" href="#489">489</a>                 connState.setProducingEntity((ProducingNHttpEntity) entity);
<a class="jxr_linenumber" name="490" href="#490">490</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="491" href="#491">491</a>                 connState.setProducingEntity(<strong class="jxr_keyword">new</strong> <a href="../../../../../org/apache/http/nio/entity/NHttpEntityWrapper.html">NHttpEntityWrapper</a>(entity));
<a class="jxr_linenumber" name="492" href="#492">492</a>             }
<a class="jxr_linenumber" name="493" href="#493">493</a>         }
<a class="jxr_linenumber" name="494" href="#494">494</a> 
<a class="jxr_linenumber" name="495" href="#495">495</a>         conn.submitResponse(response);
<a class="jxr_linenumber" name="496" href="#496">496</a> 
<a class="jxr_linenumber" name="497" href="#497">497</a>         <strong class="jxr_keyword">if</strong> (entity == <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="498" href="#498">498</a>             <strong class="jxr_keyword">if</strong> (!<strong class="jxr_keyword">this</strong>.connStrategy.keepAlive(response, context)) {
<a class="jxr_linenumber" name="499" href="#499">499</a>                 conn.close();
<a class="jxr_linenumber" name="500" href="#500">500</a>             } <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="501" href="#501">501</a>                 <em class="jxr_comment">// Ready to process new request</em>
<a class="jxr_linenumber" name="502" href="#502">502</a>                 connState.reset();
<a class="jxr_linenumber" name="503" href="#503">503</a>                 conn.requestInput();
<a class="jxr_linenumber" name="504" href="#504">504</a>             }
<a class="jxr_linenumber" name="505" href="#505">505</a>             responseComplete(response, context);
<a class="jxr_linenumber" name="506" href="#506">506</a>         }
<a class="jxr_linenumber" name="507" href="#507">507</a>     }
<a class="jxr_linenumber" name="508" href="#508">508</a> 
<a class="jxr_linenumber" name="509" href="#509">509</a>     <em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="510" href="#510">510</a> <em class="jxr_javadoccomment">     * Signals that this response has been fully sent. This will be called after</em>
<a class="jxr_linenumber" name="511" href="#511">511</a> <em class="jxr_javadoccomment">     * submitting the response to a connection, if there is no entity in the</em>
<a class="jxr_linenumber" name="512" href="#512">512</a> <em class="jxr_javadoccomment">     * response. If there is an entity, it will be called after the entity has</em>
<a class="jxr_linenumber" name="513" href="#513">513</a> <em class="jxr_javadoccomment">     * completed.</em>
<a class="jxr_linenumber" name="514" href="#514">514</a> <em class="jxr_javadoccomment">     */</em>
<a class="jxr_linenumber" name="515" href="#515">515</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> responseComplete(HttpResponse response, HttpContext context) {
<a class="jxr_linenumber" name="516" href="#516">516</a>     }
<a class="jxr_linenumber" name="517" href="#517">517</a> 
<a class="jxr_linenumber" name="518" href="#518">518</a>     <strong class="jxr_keyword">private</strong> <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandler.html">NHttpRequestHandler</a> getRequestHandler(HttpRequest request) {
<a class="jxr_linenumber" name="519" href="#519">519</a>         <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandler.html">NHttpRequestHandler</a> handler = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="520" href="#520">520</a>          <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.handlerResolver != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="521" href="#521">521</a>              String requestURI = request.getRequestLine().getUri();
<a class="jxr_linenumber" name="522" href="#522">522</a>              handler = <strong class="jxr_keyword">this</strong>.handlerResolver.lookup(requestURI);
<a class="jxr_linenumber" name="523" href="#523">523</a>          }
<a class="jxr_linenumber" name="524" href="#524">524</a> 
<a class="jxr_linenumber" name="525" href="#525">525</a>          <strong class="jxr_keyword">return</strong> handler;
<a class="jxr_linenumber" name="526" href="#526">526</a>     }
<a class="jxr_linenumber" name="527" href="#527">527</a> 
<a class="jxr_linenumber" name="528" href="#528">528</a>     <strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> {
<a class="jxr_linenumber" name="529" href="#529">529</a> 
<a class="jxr_linenumber" name="530" href="#530">530</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandler.html">NHttpRequestHandler</a> requestHandler;
<a class="jxr_linenumber" name="531" href="#531">531</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> HttpRequest request;
<a class="jxr_linenumber" name="532" href="#532">532</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../../org/apache/http/nio/entity/ConsumingNHttpEntity.html">ConsumingNHttpEntity</a> consumingEntity;
<a class="jxr_linenumber" name="533" href="#533">533</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> HttpResponse response;
<a class="jxr_linenumber" name="534" href="#534">534</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <a href="../../../../../org/apache/http/nio/entity/ProducingNHttpEntity.html">ProducingNHttpEntity</a> producingEntity;
<a class="jxr_linenumber" name="535" href="#535">535</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> IOException ioex;
<a class="jxr_linenumber" name="536" href="#536">536</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> HttpException httpex;
<a class="jxr_linenumber" name="537" href="#537">537</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <strong class="jxr_keyword">boolean</strong> handled;
<a class="jxr_linenumber" name="538" href="#538">538</a> 
<a class="jxr_linenumber" name="539" href="#539">539</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> finishInput() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="540" href="#540">540</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.consumingEntity != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="541" href="#541">541</a>                 <strong class="jxr_keyword">this</strong>.consumingEntity.finish();
<a class="jxr_linenumber" name="542" href="#542">542</a>                 <strong class="jxr_keyword">this</strong>.consumingEntity = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="543" href="#543">543</a>             }
<a class="jxr_linenumber" name="544" href="#544">544</a>         }
<a class="jxr_linenumber" name="545" href="#545">545</a> 
<a class="jxr_linenumber" name="546" href="#546">546</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> finishOutput() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="547" href="#547">547</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.producingEntity != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="548" href="#548">548</a>                 <strong class="jxr_keyword">this</strong>.producingEntity.finish();
<a class="jxr_linenumber" name="549" href="#549">549</a>                 <strong class="jxr_keyword">this</strong>.producingEntity = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="550" href="#550">550</a>             }
<a class="jxr_linenumber" name="551" href="#551">551</a>         }
<a class="jxr_linenumber" name="552" href="#552">552</a> 
<a class="jxr_linenumber" name="553" href="#553">553</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> reset() <strong class="jxr_keyword">throws</strong> IOException {
<a class="jxr_linenumber" name="554" href="#554">554</a>             finishInput();
<a class="jxr_linenumber" name="555" href="#555">555</a>             <strong class="jxr_keyword">this</strong>.request = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="556" href="#556">556</a>             finishOutput();
<a class="jxr_linenumber" name="557" href="#557">557</a>             <strong class="jxr_keyword">this</strong>.handled = false;
<a class="jxr_linenumber" name="558" href="#558">558</a>             <strong class="jxr_keyword">this</strong>.response = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="559" href="#559">559</a>             <strong class="jxr_keyword">this</strong>.ioex = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="560" href="#560">560</a>             <strong class="jxr_keyword">this</strong>.httpex = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="561" href="#561">561</a>             <strong class="jxr_keyword">this</strong>.requestHandler = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="562" href="#562">562</a>         }
<a class="jxr_linenumber" name="563" href="#563">563</a> 
<a class="jxr_linenumber" name="564" href="#564">564</a>         <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandler.html">NHttpRequestHandler</a> getRequestHandler() {
<a class="jxr_linenumber" name="565" href="#565">565</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.requestHandler;
<a class="jxr_linenumber" name="566" href="#566">566</a>         }
<a class="jxr_linenumber" name="567" href="#567">567</a> 
<a class="jxr_linenumber" name="568" href="#568">568</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setRequestHandler(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/protocol/NHttpRequestHandler.html">NHttpRequestHandler</a> requestHandler) {
<a class="jxr_linenumber" name="569" href="#569">569</a>             <strong class="jxr_keyword">this</strong>.requestHandler = requestHandler;
<a class="jxr_linenumber" name="570" href="#570">570</a>         }
<a class="jxr_linenumber" name="571" href="#571">571</a> 
<a class="jxr_linenumber" name="572" href="#572">572</a>         <strong class="jxr_keyword">public</strong> HttpRequest getRequest() {
<a class="jxr_linenumber" name="573" href="#573">573</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.request;
<a class="jxr_linenumber" name="574" href="#574">574</a>         }
<a class="jxr_linenumber" name="575" href="#575">575</a> 
<a class="jxr_linenumber" name="576" href="#576">576</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setRequest(<strong class="jxr_keyword">final</strong> HttpRequest request) {
<a class="jxr_linenumber" name="577" href="#577">577</a>             <strong class="jxr_keyword">this</strong>.request = request;
<a class="jxr_linenumber" name="578" href="#578">578</a>         }
<a class="jxr_linenumber" name="579" href="#579">579</a> 
<a class="jxr_linenumber" name="580" href="#580">580</a>         <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/nio/entity/ConsumingNHttpEntity.html">ConsumingNHttpEntity</a> getConsumingEntity() {
<a class="jxr_linenumber" name="581" href="#581">581</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.consumingEntity;
<a class="jxr_linenumber" name="582" href="#582">582</a>         }
<a class="jxr_linenumber" name="583" href="#583">583</a> 
<a class="jxr_linenumber" name="584" href="#584">584</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setConsumingEntity(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/entity/ConsumingNHttpEntity.html">ConsumingNHttpEntity</a> consumingEntity) {
<a class="jxr_linenumber" name="585" href="#585">585</a>             <strong class="jxr_keyword">this</strong>.consumingEntity = consumingEntity;
<a class="jxr_linenumber" name="586" href="#586">586</a>         }
<a class="jxr_linenumber" name="587" href="#587">587</a> 
<a class="jxr_linenumber" name="588" href="#588">588</a>         <strong class="jxr_keyword">public</strong> HttpResponse getResponse() {
<a class="jxr_linenumber" name="589" href="#589">589</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.response;
<a class="jxr_linenumber" name="590" href="#590">590</a>         }
<a class="jxr_linenumber" name="591" href="#591">591</a> 
<a class="jxr_linenumber" name="592" href="#592">592</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setResponse(<strong class="jxr_keyword">final</strong> HttpResponse response) {
<a class="jxr_linenumber" name="593" href="#593">593</a>             <strong class="jxr_keyword">this</strong>.response = response;
<a class="jxr_linenumber" name="594" href="#594">594</a>         }
<a class="jxr_linenumber" name="595" href="#595">595</a> 
<a class="jxr_linenumber" name="596" href="#596">596</a>         <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/nio/entity/ProducingNHttpEntity.html">ProducingNHttpEntity</a> getProducingEntity() {
<a class="jxr_linenumber" name="597" href="#597">597</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.producingEntity;
<a class="jxr_linenumber" name="598" href="#598">598</a>         }
<a class="jxr_linenumber" name="599" href="#599">599</a> 
<a class="jxr_linenumber" name="600" href="#600">600</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setProducingEntity(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/entity/ProducingNHttpEntity.html">ProducingNHttpEntity</a> producingEntity) {
<a class="jxr_linenumber" name="601" href="#601">601</a>             <strong class="jxr_keyword">this</strong>.producingEntity = producingEntity;
<a class="jxr_linenumber" name="602" href="#602">602</a>         }
<a class="jxr_linenumber" name="603" href="#603">603</a> 
<a class="jxr_linenumber" name="604" href="#604">604</a>         <strong class="jxr_keyword">public</strong> IOException getIOException() {
<a class="jxr_linenumber" name="605" href="#605">605</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.ioex;
<a class="jxr_linenumber" name="606" href="#606">606</a>         }
<a class="jxr_linenumber" name="607" href="#607">607</a> 
<a class="jxr_linenumber" name="608" href="#608">608</a>         <strong class="jxr_keyword">public</strong> IOException getIOExepction() {
<a class="jxr_linenumber" name="609" href="#609">609</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.ioex;
<a class="jxr_linenumber" name="610" href="#610">610</a>         }
<a class="jxr_linenumber" name="611" href="#611">611</a> 
<a class="jxr_linenumber" name="612" href="#612">612</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setIOException(<strong class="jxr_keyword">final</strong> IOException ex) {
<a class="jxr_linenumber" name="613" href="#613">613</a>             <strong class="jxr_keyword">this</strong>.ioex = ex;
<a class="jxr_linenumber" name="614" href="#614">614</a>         }
<a class="jxr_linenumber" name="615" href="#615">615</a> 
<a class="jxr_linenumber" name="616" href="#616">616</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setIOExepction(<strong class="jxr_keyword">final</strong> IOException ex) {
<a class="jxr_linenumber" name="617" href="#617">617</a>             <strong class="jxr_keyword">this</strong>.ioex = ex;
<a class="jxr_linenumber" name="618" href="#618">618</a>         }
<a class="jxr_linenumber" name="619" href="#619">619</a> 
<a class="jxr_linenumber" name="620" href="#620">620</a>         <strong class="jxr_keyword">public</strong> HttpException getHttpException() {
<a class="jxr_linenumber" name="621" href="#621">621</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.httpex;
<a class="jxr_linenumber" name="622" href="#622">622</a>         }
<a class="jxr_linenumber" name="623" href="#623">623</a> 
<a class="jxr_linenumber" name="624" href="#624">624</a>         <strong class="jxr_keyword">public</strong> HttpException getHttpExepction() {
<a class="jxr_linenumber" name="625" href="#625">625</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.httpex;
<a class="jxr_linenumber" name="626" href="#626">626</a>         }
<a class="jxr_linenumber" name="627" href="#627">627</a> 
<a class="jxr_linenumber" name="628" href="#628">628</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setHttpException(<strong class="jxr_keyword">final</strong> HttpException ex) {
<a class="jxr_linenumber" name="629" href="#629">629</a>             <strong class="jxr_keyword">this</strong>.httpex = ex;
<a class="jxr_linenumber" name="630" href="#630">630</a>         }
<a class="jxr_linenumber" name="631" href="#631">631</a> 
<a class="jxr_linenumber" name="632" href="#632">632</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setHttpExepction(<strong class="jxr_keyword">final</strong> HttpException ex) {
<a class="jxr_linenumber" name="633" href="#633">633</a>             <strong class="jxr_keyword">this</strong>.httpex = ex;
<a class="jxr_linenumber" name="634" href="#634">634</a>         }
<a class="jxr_linenumber" name="635" href="#635">635</a> 
<a class="jxr_linenumber" name="636" href="#636">636</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">boolean</strong> isHandled() {
<a class="jxr_linenumber" name="637" href="#637">637</a>             <strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">this</strong>.handled;
<a class="jxr_linenumber" name="638" href="#638">638</a>         }
<a class="jxr_linenumber" name="639" href="#639">639</a> 
<a class="jxr_linenumber" name="640" href="#640">640</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> setHandled(<strong class="jxr_keyword">boolean</strong> handled) {
<a class="jxr_linenumber" name="641" href="#641">641</a>             <strong class="jxr_keyword">this</strong>.handled = handled;
<a class="jxr_linenumber" name="642" href="#642">642</a>         }
<a class="jxr_linenumber" name="643" href="#643">643</a> 
<a class="jxr_linenumber" name="644" href="#644">644</a>     }
<a class="jxr_linenumber" name="645" href="#645">645</a> 
<a class="jxr_linenumber" name="646" href="#646">646</a>     <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">static</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../org/apache/http/nio/protocol/AsyncNHttpServiceHandler.html">ResponseTriggerImpl</a> <strong class="jxr_keyword">implements</strong> <a href="../../../../../org/apache/http/nio/protocol/NHttpResponseTrigger.html">NHttpResponseTrigger</a> {
<a class="jxr_linenumber" name="647" href="#647">647</a> 
<a class="jxr_linenumber" name="648" href="#648">648</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState;
<a class="jxr_linenumber" name="649" href="#649">649</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/IOControl.html">IOControl</a> iocontrol;
<a class="jxr_linenumber" name="650" href="#650">650</a> 
<a class="jxr_linenumber" name="651" href="#651">651</a>         <strong class="jxr_keyword">private</strong> <strong class="jxr_keyword">volatile</strong> <strong class="jxr_keyword">boolean</strong> triggered;
<a class="jxr_linenumber" name="652" href="#652">652</a> 
<a class="jxr_linenumber" name="653" href="#653">653</a>         <strong class="jxr_keyword">public</strong> <a href="../../../../../org/apache/http/nio/protocol/AsyncNHttpServiceHandler.html">ResponseTriggerImpl</a>(<strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/protocol/ThrottlingHttpServiceHandler.html">ServerConnState</a> connState, <strong class="jxr_keyword">final</strong> <a href="../../../../../org/apache/http/nio/IOControl.html">IOControl</a> iocontrol) {
<a class="jxr_linenumber" name="654" href="#654">654</a>             <strong class="jxr_keyword">super</strong>();
<a class="jxr_linenumber" name="655" href="#655">655</a>             <strong class="jxr_keyword">this</strong>.connState = connState;
<a class="jxr_linenumber" name="656" href="#656">656</a>             <strong class="jxr_keyword">this</strong>.iocontrol = iocontrol;
<a class="jxr_linenumber" name="657" href="#657">657</a>         }
<a class="jxr_linenumber" name="658" href="#658">658</a> 
<a class="jxr_linenumber" name="659" href="#659">659</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> submitResponse(<strong class="jxr_keyword">final</strong> HttpResponse response) {
<a class="jxr_linenumber" name="660" href="#660">660</a>             Args.notNull(response, <span class="jxr_string">"Response"</span>);
<a class="jxr_linenumber" name="661" href="#661">661</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.triggered) {
<a class="jxr_linenumber" name="662" href="#662">662</a>                 <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalStateException(<span class="jxr_string">"Response already triggered"</span>);
<a class="jxr_linenumber" name="663" href="#663">663</a>             }
<a class="jxr_linenumber" name="664" href="#664">664</a>             <strong class="jxr_keyword">this</strong>.triggered = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="665" href="#665">665</a>             <strong class="jxr_keyword">this</strong>.connState.setResponse(response);
<a class="jxr_linenumber" name="666" href="#666">666</a>             <strong class="jxr_keyword">this</strong>.iocontrol.requestOutput();
<a class="jxr_linenumber" name="667" href="#667">667</a>         }
<a class="jxr_linenumber" name="668" href="#668">668</a> 
<a class="jxr_linenumber" name="669" href="#669">669</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> handleException(<strong class="jxr_keyword">final</strong> HttpException ex) {
<a class="jxr_linenumber" name="670" href="#670">670</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.triggered) {
<a class="jxr_linenumber" name="671" href="#671">671</a>                 <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalStateException(<span class="jxr_string">"Response already triggered"</span>);
<a class="jxr_linenumber" name="672" href="#672">672</a>             }
<a class="jxr_linenumber" name="673" href="#673">673</a>             <strong class="jxr_keyword">this</strong>.triggered = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="674" href="#674">674</a>             <strong class="jxr_keyword">this</strong>.connState.setHttpException(ex);
<a class="jxr_linenumber" name="675" href="#675">675</a>             <strong class="jxr_keyword">this</strong>.iocontrol.requestOutput();
<a class="jxr_linenumber" name="676" href="#676">676</a>         }
<a class="jxr_linenumber" name="677" href="#677">677</a> 
<a class="jxr_linenumber" name="678" href="#678">678</a>         <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> handleException(<strong class="jxr_keyword">final</strong> IOException ex) {
<a class="jxr_linenumber" name="679" href="#679">679</a>             <strong class="jxr_keyword">if</strong> (<strong class="jxr_keyword">this</strong>.triggered) {
<a class="jxr_linenumber" name="680" href="#680">680</a>                 <strong class="jxr_keyword">throw</strong> <strong class="jxr_keyword">new</strong> IllegalStateException(<span class="jxr_string">"Response already triggered"</span>);
<a class="jxr_linenumber" name="681" href="#681">681</a>             }
<a class="jxr_linenumber" name="682" href="#682">682</a>             <strong class="jxr_keyword">this</strong>.triggered = <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="683" href="#683">683</a>             <strong class="jxr_keyword">this</strong>.connState.setIOException(ex);
<a class="jxr_linenumber" name="684" href="#684">684</a>             <strong class="jxr_keyword">this</strong>.iocontrol.requestOutput();
<a class="jxr_linenumber" name="685" href="#685">685</a>         }
<a class="jxr_linenumber" name="686" href="#686">686</a> 
<a class="jxr_linenumber" name="687" href="#687">687</a>     }
<a class="jxr_linenumber" name="688" href="#688">688</a> 
<a class="jxr_linenumber" name="689" href="#689">689</a> }
</pre>
<hr/><div id="footer">This page was automatically generated by <a href="http://maven.apache.org/">Maven</a></div></body>
</html>

